m4_dnl Manage lists of auxiliary (locally used and locally defined)
m4_dnl variables:
m4_dnl 
m4_dnl Usage:
m4_dnl 
m4_dnl newLocalVariables
m4_dnl typeOfLocalVariables(`real', `#real')
m4_dnl getLocalVariable(`real', `j_s_bach')
m4_dnl getLocalVariable(`real', `a_vivaldi')
m4_dnl recycleLocalVariable(`j_s_bach')
m4_dnl getLocalVariable(`real', `g_f_handel')
m4_dnl dumpLocalVariables
m4_dnl 
m4_dnl The last call should generate definitions for *two* variables of type
m4_dnl `#real', the first of which is identified with `j_s_bach' as well as
m4_dnl with `g_f_handel'.
m4_dnl 
m4_dnl ATTENTION: These macros have not been tested thoroughly.
m4_dnl 
m4_dnl ________________________________________________________________
m4_dnl 
m4_dnl The information about local variables is implemented via
m4_dnl pushdef/popdef and thus can be nested. Variables of the enclosing
m4_dnl block are visible within the inner block unless shadowed and are taken
m4_dnl into account when allocating new local variables.
m4_dnl 
m4_dnl (*) Beginning of a new scope for local variables:
m4_dnl 
m4_dnl This resets the lists:
m4_dnl 
m4_define(`newLocalVariables',
 `m4_pushdef(`local variables', `,')m4_pushdef(`local types', `,')')
m4_dnl 
m4_dnl (*) Type of local variables:
m4_dnl 
m4_dnl This macro associates a base name ($1) with a type declaration ($2);
m4_dnl the real variable names are formed by appending some number to the
m4_dnl base name. In case of multiple indications for the same base name the
m4_dnl last one takes precedence.
m4_dnl 
m4_define(`typeOfLocalVariables',
 `m4_ifelse(m4_index(m4_defn(`local types'), `,$1,'), -1,
   `m4_pushdef(
      `local type $1')m4_define(`local types',
             m4_defn(`local types')`$1,')')m4_define(`local type $1', `$2')')
m4_dnl 
m4_dnl (*) Assign next local variable:
m4_dnl 
m4_dnl This macro takes a base name and a meta-language identifier, and sets
m4_dnl up a definition for the latter to expand to a variable of the type
m4_dnl associated with the base name. Variable re-use is achieved by looking
m4_dnl for the first variable currently not used.
m4_dnl 
m4_define(`getLocalVariable',
 `m4_pushdef(`__get__', m4_changequote([,])[m4_ifelse(
   )m4_ifelse(m4_ifdef(`local variable $1_$][1',
                       `m4_len(m4_indir(`local variable $1_$][1'))', 0),
              0, `$1_$][1', `$][0(m4_incr($][1))')]m4_changequote)m4_ifelse(
 )m4_pushdef(`__var__', __get__(0))m4_ifelse(
 )m4_pushdef(`$2', __var__)m4_ifelse(
 )m4_ifelse(m4_index(m4_defn(`local variables'), `,'__var__`,'), -1,
   `m4_pushdef(`local variable '__var__)m4_ifelse(
   )m4_define(`local variables',
              m4_defn(`local variables')__var__`,')')m4_ifelse(
 )m4_define(`local variable '__var__,
            `$2')m4_popdef(`__get__')m4_popdef(`__var__')')
m4_dnl 
m4_dnl (*) Recycle local variable:
m4_dnl 
m4_dnl A local variable that is no longer used should be handed to the
m4_dnl following macro. It is an error to recycle the same variable
m4_dnl twice.
m4_dnl 
m4_define(`recycleLocalVariable',
 `m4_define(`local variable 'm4_indir(`$1'))m4_popdef(`$1')')
m4_dnl 
m4_dnl (*) Dump declarations:
m4_dnl 
m4_dnl The following macro should be used inside some diversion; it produces
m4_dnl declarations for all the variables defined in the current scope for
m4_dnl local variables. As this makes sense only at the end of the scope,
m4_dnl this also destroys the lists. If nesting scopes, make sure to recycle
m4_dnl any variables before calling this macro.
m4_dnl 
m4_define(`dumpLocalVariables',
 `m4_pushdef(`__aux__', m4_changequote([,])[m4_ifelse($][1,,,
   `m4_indir(`local type 'm4_patsubst($][1, _[0-9]+$)) :: $][1
m4_ifdef(`local variable $][1',
             `m4_popdef(m4_defn(`local variable $][1'))')m4_ifelse(
   )m4_popdef(`local variable $][1')m4_ifelse(
)$][0(m4_shift($][@))')]m4_changequote)m4_ifelse(
 )__aux__(m4_shift(m4_indir(`local variables')))m4_ifelse(
 )m4_define(`__aux__', m4_changequote([,])[m4_ifelse($][1,,,
   `m4_popdef(`local type $][1')')]m4_changequote)m4_ifelse(
 )__aux__(m4_shift(m4_indir(`local types')))m4_ifelse(
 )m4_popdef(`__aux__')m4_popdef(`local variables')m4_popdef(`local types')')
