m4_dnl`  Check whether macro (first argument) is any of a list of values  '
m4_dnl`  (other arguments). Example:                                      '
m4_dnl`	                                                                  '
m4_dnl`	 1) checkrange(asdf, nNew, nMid, nOld) -> --error                 '
m4_dnl`	 2) checkrange(nNew, nNew, nMid, nOld) -> --ok                    '
m4_dnl`	                                                                  '
m4_dnl`	 m4_ifelse(checkrange(asdf, nNew, nMid, nOld), --ok, Super, Die)  '
m4_dnl`	 m4_ifelse(checkrange(nNew, nNew, nMid, nOld), --ok, Super, Die)  '

m4_define(`checkrange', `m4_ifelse($1, $2,--ok,`m4_ifelse(m4_len($2),0,--error,
`$0($1, m4_shift(m4_shift($@)))')')')


m4_dnl`  To simply put an error message into the target file, use         '
m4_dnl`  the following macro; e.g. `m4_checkrange(`asdf', yes, no)'       '
m4_dnl`  (note that the first argument must be quoted!) will either       '
m4_dnl`  have a void expansion or output:                                 '
m4_dnl`	   --error: "asdf" is                                             '
m4_dnl`	   --error: "asdf", should be any of:                             '
m4_dnl`	   --error: yes,no.                                               '
m4_dnl`  The expansion will also go to diversion CHECKS_M4, cf. `.m'      '

m4_define(`m4_checkrange', `m4_ifelse(checkrange($@), --error, `
  --error: "`$1'" is
  --error: "$1", should be any of:
  --error: m4_shift($@).
..CHECKS_M4>>
  --error: "`$1'" is
  --error: "$1", should be any of:
  --error: m4_shift($@).
<<CHECKS_M4..')')

m4_dnl`  To check whether a given macro is defined, use the following;    '
m4_dnl`  it behaves roughly like m4_checkrange.                           '

m4_define(`m4_checkdef', `m4_ifdef(`$1',, `
  --error: "`$1'" is not defined.
..CHECKS_M4>>
  --error: "`$1'" is not defined.
<<CHECKS_M4..')')


