m4_dnl 
m4_dnl Macros related to mathematical evaluations.
m4_dnl 
m4_dnl fastExp__...: fast exponentiation code generation
m4_dnl 
m4_dnl ---------------------------------------------------------------------
m4_dnl fastExp__argAtom_powerInteger_result_factor_auxil:
m4_dnl raisePower__arg_powerInteger_result_factor_auxil:
m4_dnl      generate code for fast exponentiation with positive integer
m4_dnl        powers.
m4_dnl      arguments:
m4_dnl        $1: argument
m4_dnl        $2: power, must be integer
m4_dnl        $3: result variable, must be atomic
m4_dnl        $4: optional pre-factor, may be an expression
m4_dnl        $5: auxiliary variable, must be atomic
m4_dnl Note that raisePower__... destructively raises $1 to the power of $2,
m4_dnl while fastExp__... preserves the value of $1; furthermore, the first
m4_dnl argument to raisePower__... must be atomic. The code produced is far
m4_dnl from optimal; a reasonable compiler should do a better job on Fortran's
m4_dnl usual ** with integer exponent.
m4_define(`raisePower__argAtom_powerInteger_result_factor_auxil',
 `m4_ifelse(
    m4_eval($2<0), 1, `
       $1 = 1/$1
       $0(`$1', m4_eval(-($2)), `$3', `$4', `$5')',
    $2, 3, `
       $3 = $1*$1*$1`'m4_ifelse(`$4',`',,`*$4')',
    $2, 2, `
       $3 = $1*$1`'m4_ifelse(`$4',`',,`*$4')',
    $1, 1, `        #c-------- just in case we call with `1' explicitly
       $3 = $1`'m4_ifelse(`$4',`',,`*$4')',
    $2, 0, `        #c-------- return integer `1', rely on implicit conversion
       $3 = m4_ifelse(`$4', `', `1', `$4')',
    m4_eval($2%2), 0, `
       $1 = $1*$1 m4_dnl
       $0(`$1', m4_eval($2/2), `$3', `$4', `$5')',
    m4_eval($2%2), 1, `
       $5 = $1`'m4_ifelse(`$4',`',,`*$4')
       $1 = $1*$1 m4_dnl
       $0(`$1', m4_eval($2/2), `$3', `$5', `$5')',
    --error in logic)')
m4_define(`fastExp__arg_powerInteger_result_factor_auxil',
  `$3 = $1
   raisePower__argAtom_powerInteger_result_factor_auxil(`$3', `$2',
                                                        `$3', `$4', `$5')')
