m4_ifelse(`

                `If_pointers_associated':
                ~~~~~~~~~~~~~~~~~~~~~~~~~

generate Fortran-90 code for executing a code fragment only if all
pointers are associated.

And yet again we have to work around a deficiency of Fortran-90: the
lack of lazy evaluation...

Arguments: You can either hand the sequence of pointer references to
be checked and the code fragment as second argument:

    If_pointers_associated(nl%prev%prev%next%prev, hojotoho)

or you can hand a node (with trailing %) that is supposed to be known
as existant, a sequence of pointer references relative to that node,
and the code fragment as third argument:

    If_pointers_associated(nl%prev%,prev%next%prev, heia ha)

')
m4_define(`If_pointers_associated',
`m4_ifelse($#,2,`$0(,`$1',`$2')',
           `$2',,`$3',
           `m4_pushdef(`i', m4_index(`$2%',`%'))m4_ifelse(
            )if (associated($1`'m4_substr(`$2',0,i))) then
              $0($1`'m4_substr(`$2',0,i)%,
                 m4_substr(`$2',m4_incr(i)),
                 `$3')
            end if`'m4_popdef(`i')')')
