m4_ifelse(m4_changequote([[[,]]])[[[

Code for saving tNode-components: For every tNode-component to be
saved we have to provide (cf. files.arfg, module Structured_IO) a
description (of type string, i.e. character (len=__StringLength__))

Arguments: $1: Description string.
           $2: tNode component (may involve %).
	   $3: Type of component; cf. file.arfg's macro `types' for
	       legal values.
	   $4: if present, this indicates that $2 is an array component.

Example code:

save_tNodeComponent__descr_component_type_(`f (auxil. fun)', f, Real)
save_tNodeComponent__descr_component_type_(`M (cc. matrix)', cc_M, Real,)
save_tNodeComponent__descr_component_type_(`f (auxil. fun)', f, Real)
save_tNodeComponent__descr_component_type_(`M (cc. matrix)', cc_M, Real,)
save_tNodeComponent__descr_component_type_(`Line', line, String)
save_tNodeComponent__descr_component_type_(`Text', text, String,)

save_tNodeComponent_description__lun_node(lun,node)
save_tNodeComponent_save__lun_node(lun,node)
save_tNodeComponent_list_

<-------------------------------------------------------------------------->

Analogously we can use `save_GeneralInfo__descr_data_type' to save
additional information (scalar values only):

save_GeneralInfo__descr_data_type(first parameter, p1, real)
save_GeneralInfo__lun(lun)

]]]m4_changequote)m4_dnl
m4_define(`save_tNodeComponent__descr_component_type_',
  `m4_pushdef(`__aux__', m4_translit(`.$2.',`a-z',`A-Z'))m4_dnl
   m4_ifelse(m4_index(save_tNodeComponent_list_,__aux__),-1,
   `m4_define(`save_tNodeComponent_list_',
      m4_defn(`save_tNodeComponent_list_')__aux__)m4_dnl
    m4_define(`save_tNodeComponent_description__lun_node',
      m4_defn(`save_tNodeComponent_description__lun_node')
      call Write_Item($`'1, IOsel_Descr`'$3, &
          strings = (/ str("$1") /)`'m4_ifelse($#,4,`, &
 	  integers = shape($`'2%$2)')))m4_dnl
    m4_define(`save_tNodeComponent_save__lun_node',
      m4_defn(`save_tNodeComponent_save__lun_node')
      call Write_Item($`'1, IOsel_`'$3, $3`'s = m4_ifelse($#,4,
 	  `pack($`'2%$2, .true.)', (/`$`'2%$2'/))))m4_dnl
   ')m4_popdef(`__aux__')m4_dnl
  'm4_dnl
)m4_dnl
m4_define(`save_GeneralInfo__descr_data_type',
  `m4_define(`save_GeneralInfo__lun', m4_defn(`save_GeneralInfo__lun')m4_dnl
    `call Write_Item`'($'`1, IOsel_Info`'$3, &
       'm4_ifelse(
         m4_translit(`$3', `a-z', `A-Z'), STRING,
         ``Strings=(/ str`'("$1"), &
              $2 /)'',
         ``Strings=(/ str`'("$1") /), &
          $3s=(/ $2 /)'')`)
  ')
')m4_dnl
